# $Id: tree.rb,v 1.3 2002/04/15 04:16:41 tommy Exp $

def print_tree(path, m, del=nil, indent='', subj='', cur=nil)
  nsubj = m.subject.gsub(/\s+/, '').sub(/^(Re:)+/i, '')
  if cur then
    if m.no == cur then
      print "<span class=\"current\">-&gt;&nbsp;"
    else
      print "<span>&nbsp;&nbsp;&nbsp;"
    end
  end
  printf "<a href=\"%s\">%s %5d %s %s[%-20.20s] %-#{40-indent.length}s</a>",
    "#{path}/msg/#{m.no}",
    m.have_attach? ? $WithAttachHTML[0] : $WithAttachHTML[1],
    m.no,
    m.time.strftime('%Y-%m-%d %H:%M'),
    indent,
    escapeHTML(m.from),
    if subj == nsubj then '' else m.subject end
  puts "</span>"
  del[m.no] = true if del
  indent.gsub!(//, '')
  indent.gsub!(//, '')
  m.followed.each_index do |i|
    if i == m.followed.length-1 then ii = '' else ii = '' end
    print_tree(path, Message::new(m.ml, m.followed[i]), del, indent+ii, nsubj, cur)
  end
end
