# $Id: w3ml.rb,v 1.4 2002/06/25 14:37:51 tommy Exp $

def escapeHTML(str)
  str.gsub(/&/n, '&amp;').gsub(/\"/n, '&quot;').gsub(/>/n, '&gt;').gsub(/</n, '&lt;')
end

def escapeURL(str)
  str.gsub(/([^ a-zA-Z0-9_.-]+)/n) do
    '%' + $1.unpack('H2' * $1.size).join('%').upcase
  end.tr(' ', '+')
end

def not_found()
  puts <<EOS
Status: 404 Not Found
Content-Type: text/html

<h1>Not Found</h1>
EOS
  exit
end

def require_slash()
  puts "Status: 301 Moved Permanently\n"
  puts "Location: #{ENV['REQUEST_URI']}/\n\n"
  exit
end

require LIB_DIR+'w3ml-'+$Database
